function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * Copyright 2021 Tridium, Inc. All Rights Reserved.
 */

/* eslint-env browser */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/ux/PeakTrackerView
 */
define(['baja!', 'bajaux/mixin/subscriberMixIn', 'bajaux/spandrel', 'underscore', 'nmodule/webEditors/rc/wb/profile/profileUtils', 'nmodule/bajaui/rc/util/pxUtils', 'nmodule/webEditors/rc/wb/table/Table', 'nmodule/webEditors/rc/wb/table/model/TableModel', 'nmodule/webEditors/rc/wb/table/model/columns/PropertyColumn', 'nmodule/bajaui/rc/model/UxModelSupport', 'lex!vykonPro'], function (baja, subscriberMixIn, spandrel, _, profileUtils, pxUtils, Table, TableModel, PropertyColumn, UxModelSupport, lexs) {
  'use strict';

  var _lexs = _slicedToArray(lexs, 1),
      vykonLexicon = _lexs[0],
      widgetDefaults = function widgetDefaults() {
    return {
      properties: {
        showTitle: true
      }
    };
  };

  var MONTHS = ['january', 'february', 'march', 'april', 'may', 'june', 'july', 'august', 'september', 'october', 'november', 'december'];
  /**
   * @class
   * @alias module:nmodule/vykonPro/rc/PeakTrackerView
   * @extends {module:bajaux/Widget}
   */

  return /*#__PURE__*/function (_spandrel) {
    _inherits(PeakTrackerView, _spandrel);

    var _super = _createSuper(PeakTrackerView);

    function PeakTrackerView(params) {
      var _this;

      _classCallCheck(this, PeakTrackerView);

      _this = _super.call(this, {
        params: params,
        defaults: widgetDefaults()
      });
      UxModelSupport(_assertThisInitialized(_this));
      subscriberMixIn(_assertThisInitialized(_this));
      return _this;
    }

    _createClass(PeakTrackerView, [{
      key: "doInitialize",
      value: function doInitialize(dom) {
        var _this2 = this;

        var eventHandler = function eventHandler() {
          return _this2.rerender();
        }; //underscorejs.com


        this.getSubscriber().attach('changed', _.throttle(eventHandler, 5000));
        return _get(_getPrototypeOf(PeakTrackerView.prototype), "doInitialize", this).call(this, dom);
      }
    }]);

    return PeakTrackerView;
  }(spandrel(function (model, _ref) {
    var properties = _ref.properties,
        rootElement = _ref.rootElement;
    var showTitle = properties.showTitle;
    var peakTracker = model.getValue();

    if (!peakTracker) {
      return '<div/>';
    }

    var rows = MONTHS.map(function (month) {
      return baja.$('baja:Component', {
        month: baja.$('baja:Month', month),
        timestamp: peakTracker.get(month + 'Timestamp').newCopy(),
        value: peakTracker.getValueOf(month + 'Peak').newCopy().getValue()
      });
    });
    var monthColumn = new PropertyColumn('month', {
      displayName: vykonLexicon.get('trackerView.month')
    });
    var tstampColumn = new PropertyColumn('timestamp', {
      displayName: vykonLexicon.get('trackerView.timestamp')
    });
    var valueColumn = new PropertyColumn('value', {
      displayName: vykonLexicon.get('trackerView.value')
    });
    monthColumn.setSortable(false);
    tstampColumn.data('context', {
      showSeconds: false
    });
    tstampColumn.setSortable(false);
    var valueFacets = peakTracker.get('facets').toObject();
    valueColumn.data('context', valueFacets);
    valueColumn.setSortable(false); // Table is backed by a TableModel, just a set of columns and rows

    // Table is backed by a TableModel, just a set of columns and rows
    var tableModel = new TableModel({
      columns: [monthColumn, tstampColumn, valueColumn],
      rows: rows
    });
    var div = document.createElement('div');
    div.classList.add('ux-PeakTrackerView'); // hard code density for now

    // hard code density for now
    var tableDensity = 'large';

    if (showTitle === true) {
      var textSpan = document.createElement('p');
      textSpan.innerText = peakTracker.getDisplayName() + ' - Monthly Peak Values';
      textSpan.style.textAlign = 'center';
      textSpan.style.fontWeight = 'bold';
      return [{
        dom: div,
        kids: [{
          dom: textSpan
        }, {
          dom: '<div></div>',
          type: Table,
          value: tableModel,
          properties: {
            density: 'small'
          }
        }]
      }];
    } else {
      return [{
        dom: '<div></div>',
        type: Table,
        value: tableModel,
        properties: {
          density: tableDensity
        }
      }];
    }
  }));
});
