function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * Copyright 2021 Tridium, Inc. All Rights Reserved.
 */

/* eslint-env browser */

/* global niagara */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/ux/ZoneListView
 */
define(['baja!', 'bajaux/mixin/subscriberMixIn', 'bajaux/spandrel', 'jquery', 'underscore', 'nmodule/webEditors/rc/fe/baja/util/DepthSubscriber', 'nmodule/webEditors/rc/wb/profile/profileUtils', 'nmodule/bajaui/rc/util/pxUtils', 'nmodule/webEditors/rc/wb/table/Table', 'nmodule/webEditors/rc/wb/table/model/TableModel', 'nmodule/webEditors/rc/wb/table/model/columns/PropertyColumn', 'nmodule/bajaui/rc/model/UxModelSupport', 'log!uxMedia', 'lex!vykonPro', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, subscriberMixIn, spandrel, $, _, DepthSubscriber, profileUtils, pxUtils, Table, TableModel, PropertyColumn, UxModelSupport, log, lexs) {
  'use strict';

  var logSevere = log.severe.bind(log);

  var _lexs = _slicedToArray(lexs, 1),
      vykonLexicon = _lexs[0],
      widgetDefaults = function widgetDefaults() {
    return {
      properties: {
        showTitle: true,
        hyperlink: baja.Ord.make('slot:'),
        sortAscending: false
      }
    };
  };
  /**
   * @class
   * @extends {module:bajaux/Table}
   */


  var HyperlinkTable = /*#__PURE__*/function (_Table) {
    _inherits(HyperlinkTable, _Table);

    var _super = _createSuper(HyperlinkTable);

    function HyperlinkTable() {
      _classCallCheck(this, HyperlinkTable);

      return _super.apply(this, arguments);
    }

    _createClass(HyperlinkTable, [{
      key: "doInitialize",
      value: function doInitialize(dom) {
        var _this = this;

        dom.on('click', 'tr', function (e) {
          var tableModel = _this.getModel();

          var rowIndex = $(e.currentTarget).index();
          var ord = tableModel.getRows()[rowIndex].getSubject().get('hlink');
          niagara.env.hyperlink(ord)["catch"](logSevere);
        });
        return _get(_getPrototypeOf(HyperlinkTable.prototype), "doInitialize", this).call(this, dom);
      }
    }]);

    return HyperlinkTable;
  }(Table);
  /**
   * @class
   * @alias module:nmodule/vykonPro/rc/ZoneListView
   * @extends {module:bajaux/Widget}
   */


  return /*#__PURE__*/function (_spandrel) {
    _inherits(ZoneListView, _spandrel);

    var _super2 = _createSuper(ZoneListView);

    function ZoneListView(params) {
      var _this2;

      _classCallCheck(this, ZoneListView);

      _this2 = _super2.call(this, {
        params: params,
        defaults: widgetDefaults()
      });
      UxModelSupport(_assertThisInitialized(_this2));
      subscriberMixIn(_assertThisInitialized(_this2));
      return _this2;
    }

    _createClass(ZoneListView, [{
      key: "doInitialize",
      value: function doInitialize(dom) {
        var _this3 = this;

        this.$subscriber = new DepthSubscriber(3);

        var eventHandler = function eventHandler() {
          return _this3.rerender();
        }; //underscorejs.com


        this.getSubscriber().attach('changed', _.throttle(eventHandler, 5000));
        return _get(_getPrototypeOf(ZoneListView.prototype), "doInitialize", this).call(this, dom);
      }
    }]);

    return ZoneListView;
  }(spandrel(function (model, _ref) {
    var properties = _ref.properties,
        rootElement = _ref.rootElement;
    var hyperlink = properties.hyperlink,
        showTitle = properties.showTitle,
        sortAscending = properties.sortAscending;
    var zoneListExt = model.getValue();

    if (!zoneListExt) {
      return '<div/>';
    }

    var idColumn = new PropertyColumn('zoneId', {
      displayName: vykonLexicon.get('zoneListView.zoneId')
    });
    var valueColumn = new PropertyColumn('value', {
      displayName: vykonLexicon.get('zoneListView.value')
    });
    var hyperlinkColumn = new PropertyColumn('hlink', 'hlink');
    hyperlinkColumn.setUnseen(true);
    var baseOrd = profileUtils.getCurrentOrd().relativizeToSession();
    var zoneInfoSlots = zoneListExt.getSlots().dynamic().is('vykonPro:ZoneInfo').toArray();
    return Promise.all(zoneInfoSlots.map(function (slot) {
      var zoneInfo = zoneListExt.get(slot);
      return zoneInfo.loadSlots().then(function () {
        var linkOrd = baja.Ord.make({
          base: baseOrd,
          child: zoneInfo.get('ord').normalize()
        });
        var hlinkOrd = baja.Ord.make({
          base: linkOrd,
          child: hyperlink
        }).toUri();
        return baja.$('baja:Component', {
          zoneId: zoneInfo.get('zoneId'),
          value: zoneInfo.get('out').getValueDisplay(),
          hlink: hlinkOrd
        });
      });
    })).then(function (rows) {
      if (sortAscending === true) {
        rows.sort(function (a, b) {
          return a.get('zoneId') < b.get('zoneId') ? 1 : -1;
        });
      } else {
        rows.sort(function (a, b) {
          return a.get('zoneId') > b.get('zoneId') ? 1 : -1;
        });
      }

      var tableModel = new TableModel({
        columns: [idColumn, valueColumn, hyperlinkColumn],
        rows: rows
      });
      var div = document.createElement('div');
      div.classList.add('ux-ZoneListView'); // hard code density for now

      // hard code density for now
      var tableDensity = 'large';

      if (showTitle === true) {
        var textSpan = document.createElement('p');
        textSpan.innerText = zoneListExt.getDisplayName() + ' - Out Of Range Zones';
        textSpan.style.textAlign = 'center';
        textSpan.style.fontWeight = 'bold';
        return [{
          dom: div,
          kids: [{
            dom: textSpan
          }, {
            dom: '<div></div>',
            type: HyperlinkTable,
            value: tableModel,
            properties: {
              density: tableDensity
            }
          }]
        }];
      } else {
        return [{
          dom: '<div></div>',
          type: HyperlinkTable,
          value: tableModel,
          properties: {
            density: tableDensity
          }
        }];
      }
    });
  }));
});
